// read_some_ints.cpp - the mysterious data source for our SyncReader and AsyncReader

#include <cstdlib>
#include <thread>
#include <chrono>

// "reads" some integers into buf. Purposely takes a long time. For the purpose of our exercise
// always reads at least one integer. Reads up to max integers.
// @returns a number [1, max] for how many ints it put into the buffer.
size_t readSomeInts(int buf[], size_t max)
{
    std::this_thread::sleep_for(std::chrono::milliseconds{250});

    std::srand(std::time(nullptr));
    int num_to_generate = (std::rand() % max) + 1;

    for (auto i = 0; i < num_to_generate; i++)
    {
        buf[i] = std::rand() % 1000;
    }

    return num_to_generate;
}
